<?php

$fillEmptyStr   = false;
$scandir        = __DIR__;
$destination    = __DIR__."/locale/";
$source         = __DIR__."/locale/";
$language       =   "de-DE";
$filename       =   'base.po';
$data = array();


if(isset($argv) && count($argv)>1) {
    foreach($argv as $arg) {
        if($arg[0]=='-') {
            switch($arg[1]) {
                case 'e': list(,$scandir) = explode("=",$arg); break;
                case 'd': list(,$destination) = explode("=",$arg); break;
                case 's': list(,$source) = explode("=",$arg); break;
                case 'l': list(,$language) = explode("=",$arg); break;
                case 'f': list(,$filename) = explode("=",$arg); break;
                case 'o': $fillEmptyStr=true; break;
            }
        }
    }
}

require_once('vendor/PoParser/src/Entry.php');
require_once('vendor/PoParser/src/Parser.php');
require_once('vendor/PoParser/src/Writer.php');

define("FILE_TYPE","tpl|xml");

$poFile = $source.$language."/".$filename;


if(file_exists($poFile)) {
    $parser = new PoParser\Parser();
    $parser->read($poFile);
    $entries = $parser->getEntriesAsArrays();
    foreach ($entries as $key => $value) {
        if (!empty($key)) {
            $data[md5($key)] = array('msgid' => $value['msgid'], 'msgstr' => $value['msgstr'][0]);
        }
    }
} else {
}

function getTextParser($verzeichnis = "./") {
    global $data;
    if($dir = opendir($verzeichnis))  {
        while($file = readdir($dir)) {
         $path_parts = pathinfo($file);
         if(($file != ".." && $file !="." && $file!="poedit.php") && (is_dir($verzeichnis.$file) || preg_match("/(".FILE_TYPE.")/i",$path_parts["extension"]))) {
            if(is_dir($verzeichnis.$file)) {
                getTextParser($verzeichnis.$file."/");
            } elseif(preg_match("/(".FILE_TYPE.")/i",$path_parts["extension"])) {
                echo $verzeichnis.$file."\n";
                switch($path_parts["extension"]) {
                    case 'tpl':
                        scan_tpl($fw,$verzeichnis.$file);
                        break;
                    case 'xml':
                        scan_xml($verzeichnis.$file);
                        break;
                }
            }
        }
     }
    closedir($dir);
    }
}


function scan_tpl($fp,$file) {
    global $data;
    $content = file_get_contents($file);
    if(preg_match_all("#\{__\(\'(.+?)\'\)\}#",$content,$found) >0 ) {
        echo "<pre style='text-align:left; background-color:#ffffff; color:#333333;'>".__FILE__.' / '.__LINE__."<br />".print_r($found,true)."</pre>";
        foreach($found[1] as $text) {
            if(empty($data[md5($text)])) {
                $data[md5(addcslashes ($text,'"'))] = array('msgid' => addcslashes ($text,'"'),'msgstr' => '');
            }
        }
    }
}

function scan_xml($file) {
    global $data;
    $content = file_get_contents($file);
    if(preg_match_all("#<Description>(.+?)</Description>#",$content,$found) >0 ) {
        foreach($found[1] as $text) {
            if(empty($data[md5($text)])) {
                $data[md5(addcslashes ($text,'"'))] = array('msgid' => addcslashes ($text,'"'),'msgstr' => '');
            }
        }
    }
}


getTextParser();

$fw = fopen($poFile,"w+");
foreach($data as $key => $value) {
    if(empty($value['msgstr']) && $fillEmptyStr===true){
        $value['msgstr'] = $value['msgid'];
    } else {
        $value['msgstr'] = '';
    }
     fwrite($fw, 'msgid "'.$value['msgid'].'"'."\n".'msgstr "'.$value['msgstr'].'"'."\n\n");
    }
fclose($fw);
#$entries = $parser->getEntriesAsArrays();




$parser = new PoParser\Parser();
$parser->read($poFile);



echo "<pre style='text-align:left; background-color:#ffffff; color:#333333;'>".__FILE__.' / '.__LINE__."<br />".print_r($data,true)."</pre>";
echo "<pre style='text-align:left; background-color:#ffffff; color:#333333;'>".__FILE__.' / '.__LINE__."<br />".print_r($entries,true)."</pre>";
echo "fertig";

